/*
 * Copyright (c) 2001, Thierry Van Elsuw 
 * All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met:
 * 
 * Redistributions of source code must retain the above copyright 
 * notice, this list of conditions and the following disclaimer.
 * 
 * Redistributions in binary form must reproduce the above copyright 
 * notice, this list of conditions and the following disclaimer in the 
 * documentation and/or other materials provided with the distribution.
 * 
 * Neither the name of DS Improve nor the names of its contributors may 
 * be used to endorse or promote products derived from this software 
 * without specific prior written permission.
 * 
 * Module name   : tveClock.h
 * Creation date : 14/02/2001
 * e-mail        : Thierry Van Elsuwe <tvelsuwe@swing.be>
 */

#ifndef _TVECLOCK_H_
#define _TVECLOCK_H_

#include "voyager.h"

class tveClock
{
private:
    Uint32 start_tick;
    Uint32 last_tick;
    Uint32 current_frame;
    Uint32 last_frame;
    Uint32 current_fps;

public:
    tveClock();
    void startClock();
    Uint32 getClock();
    Uint32 getCurrentFPS();
    Uint32 getTotalFPS();
    void incFrame();
    void resetFrame();
};

#endif
