/*
 * Copyright (c) 2001, Thierry Van Elsuw 
 * All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met:
 * 
 * Redistributions of source code must retain the above copyright 
 * notice, this list of conditions and the following disclaimer.
 * 
 * Redistributions in binary form must reproduce the above copyright 
 * notice, this list of conditions and the following disclaimer in the 
 * documentation and/or other materials provided with the distribution.
 * 
 * Neither the name of DS Improve nor the names of its contributors may 
 * be used to endorse or promote products derived from this software 
 * without specific prior written permission.
 * 
 * Module name   : tveDemo.h
 * Creation date : 09/03/2001
 * e-mail        : Thierry Van Elsuwe <tvelsuwe@swing.be>
 */

#ifndef _TVEDEMO_H_
#define _TVEDEMO_H_

#include "voyager.h"

const int MAX_DEMO_SIZE = 1024*32;

enum tveDemoState
{
    DEMO_STOP = 0,
    DEMO_START,
    DEMO_PAUSE,
    DEMO_RECORDING,
    DEMO_PLAYING,
    DEMO_LOOPING,
};


typedef struct
{
    tveVertex   pos;
    GLfloat     anglex;
    GLfloat     angley;
    Uint32      tick;
} tvePosition;


class tveDemo
{
private:
    int         cur_pos;
    tvePosition *pos;
    int         state;
    char        *demoname;
    bool        loop;
public:
    tveDemo();
    void start(int state, char *demoname);
    void execute();
    void togglePause();
    void stop();
};

#endif
