/*
 * Copyright (c) 2001, Thierry Van Elsuw 
 * All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met:
 * 
 * Redistributions of source code must retain the above copyright 
 * notice, this list of conditions and the following disclaimer.
 * 
 * Redistributions in binary form must reproduce the above copyright 
 * notice, this list of conditions and the following disclaimer in the 
 * documentation and/or other materials provided with the distribution.
 * 
 * Neither the name of DS Improve nor the names of its contributors may 
 * be used to endorse or promote products derived from this software 
 * without specific prior written permission.
 * 
 * Module name   : tveLandscape.h
 * Creation date : 16/02/2001
 * e-mail        : Thierry Van Elsuwe <tvelsuwe@swing.be>
 */

#ifndef _TVELANDSCAPE_H_
#define _TVELANDSCAPE_H_

#include "voyager.h"
#include "tveQuadtree.h"


class tveLandscape
{
private:
    GLuint      list_tree;
    tveQuadTree *quad_tree;

    void generate(int left, int top, int right, int bottom);
    void generate1(int left, int top, int right, int bottom);
    void generate2(int left, int top, int right, int bottom);
    void smooth();
    void generateTreeList();
    void generateQuadTreeVertexArray();
public:
    tveHeightMap *height_map;

    tveLandscape(char *filename);
    ~tveLandscape();
    void drawQuadTreeVertexArray(bool lock);
    GLfloat getYPos(GLfloat x, GLfloat z);
    void drawWater();
    void drawSky();
    void drawTrees();
};

#endif
