/*
 * Copyright (c) 2001, Thierry Van Elsuw 
 * All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met:
 * 
 * Redistributions of source code must retain the above copyright 
 * notice, this list of conditions and the following disclaimer.
 * 
 * Redistributions in binary form must reproduce the above copyright 
 * notice, this list of conditions and the following disclaimer in the 
 * documentation and/or other materials provided with the distribution.
 * 
 * Neither the name of DS Improve nor the names of its contributors may 
 * be used to endorse or promote products derived from this software 
 * without specific prior written permission.
 * 
 * Module name   : tveLists.cpp
 * Creation date : 28/03/2001
 * e-mail        : Thierry Van Elsuwe <tvelsuwe@swing.be>
 */

#include "voyager.h"
#include "tveLists.h"


/*
 *
 */
tveItem::tveItem()
{
    next = NULL;
}


/*
 *
 */
tveItem::~tveItem()
{
}


/*
 *
 */
tveQueue::tveQueue()
{
    first   = NULL;
    last    = NULL;
}


/*
 *
 */
tveQueue::~tveQueue()
{
    while (first)
    {
        tveItem *tmp = first;

        first = first->next;
        delete tmp;
    }
}


/*
 *
 */
void tveQueue::enQueue(tveItem *item)
{
    if (last)
    {
        last->next = item;
        last = item;
    }
    else
    {
        first = last = item;
    }
}


/*
 *
 */
tveItem *tveQueue::getFirst()
{
    return first;
}


/*
 *
 */
tveItem *tveQueue::deQueue()
{
    if (first)
    {
        tveItem *res = first;

        first = first->next;
        res->next = NULL;
        if (!first)
        {
            last = NULL;
        }
        return res;
    }
    return NULL;
}
