/*
 * Copyright (c) 2001, Thierry Van Elsuw 
 * All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met:
 * 
 * Redistributions of source code must retain the above copyright 
 * notice, this list of conditions and the following disclaimer.
 * 
 * Redistributions in binary form must reproduce the above copyright 
 * notice, this list of conditions and the following disclaimer in the 
 * documentation and/or other materials provided with the distribution.
 * 
 * Neither the name of DS Improve nor the names of its contributors may 
 * be used to endorse or promote products derived from this software 
 * without specific prior written permission.
 * 
 * Module name   : tveLists.h
 * Creation date : 28/03/2001
 * e-mail        : Thierry Van Elsuwe <tvelsuwe@swing.be>
 */

#ifndef _TVELISTS_H_
#define _TVELISTS_H_

#include "voyager.h"

class tveQueue;
class tveItem;

class tveItem
{
friend class tveQueue;
protected:
    tveItem *next;
public:
    tveItem();
    ~tveItem();
};

class tveQueue
{
private:
    tveItem *first;
    tveItem *last;
public:
    tveQueue();
    ~tveQueue();
    void    enQueue(tveItem *item);
    tveItem *deQueue();
    tveItem *getFirst();
};

#endif
