/*
 * Copyright (c) 2001, Thierry Van Elsuw 
 * All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met:
 * 
 * Redistributions of source code must retain the above copyright 
 * notice, this list of conditions and the following disclaimer.
 * 
 * Redistributions in binary form must reproduce the above copyright 
 * notice, this list of conditions and the following disclaimer in the 
 * documentation and/or other materials provided with the distribution.
 * 
 * Neither the name of DS Improve nor the names of its contributors may 
 * be used to endorse or promote products derived from this software 
 * without specific prior written permission.
 * 
 * Module name   : tvePattern.h
 * Creation date : 23/02/2001
 * e-mail        : Thierry Van Elsuwe <tvelsuwe@swing.be>
 */

#ifndef _TVEPATTERN_H_
#define _TVEPATTERN_H_

#include "voyager.h"
#include "tveHeightmap.h"

#define LEAF_GRANULARITY        16
#define LEAF_GRANULARITY_SHIFT  4
#define LEAF_GRANULARITY_SQR    (LEAF_GRANULARITY*LEAF_GRANULARITY)

class tveQuadTree;

class tvePattern
{
protected:
    int pass;
public:
    bool         detail;
    tveHeightMap *height_map;
    tveQuadTree  *top;
    tvePattern();
    void setPass(int pass);
    virtual void render(float y, int dir) = 0;
};


class tveVertexArray : public tvePattern
{
public:
    tveTexCoord     *tex_coord[2]; //FIXME
    tveRGBA         *color[2];
    tveVertex       *vertices;
    GLuint          *faces_strip_detail;
    GLuint          *faces_strip_coarse;

    tveVertexArray();
    virtual ~tveVertexArray();
    void render(float y, int dir);
    void drawArray(int dir);
};

#endif
