/*
 * Copyright (c) 2001, Thierry Van Elsuw 
 * All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met:
 * 
 * Redistributions of source code must retain the above copyright 
 * notice, this list of conditions and the following disclaimer.
 * 
 * Redistributions in binary form must reproduce the above copyright 
 * notice, this list of conditions and the following disclaimer in the 
 * documentation and/or other materials provided with the distribution.
 * 
 * Neither the name of DS Improve nor the names of its contributors may 
 * be used to endorse or promote products derived from this software 
 * without specific prior written permission.
 * 
 * Module name   : tveVoyager.cpp
 * Creation date : 21/02/2001
 * e-mail        : Thierry Van Elsuwe <tvelsuwe@swing.be>
 */

#include "voyager.h"
#include "tveVoyager.h"
#include "tveTexture.h"
#include <fcntl.h>

char tveVoyager::path[256];
tveConsoleVariable *tveVoyager::cv_alpha;
tveConsoleVariable *tveVoyager::cv_beta;
tveConsoleVariable *tveVoyager::cv_gamma;
tveConsoleVariable *tveVoyager::cv_far;
tveConsoleVariable *tveVoyager::cv_fog;
tveConsoleVariable *tveVoyager::cv_fov;
tveConsoleVariable *tveVoyager::cv_speed;
tveConsoleVariable *tveVoyager::cv_water;
tveConsoleVariable *tveVoyager::cv_detail;
tveConsoleVariable *tveVoyager::cv_posx;
tveConsoleVariable *tveVoyager::cv_posy;
tveConsoleVariable *tveVoyager::cv_posz;
tveConsoleVariable *tveVoyager::cv_anglex;
tveConsoleVariable *tveVoyager::cv_angley;
tveConsoleVariable *tveVoyager::cv_screenwidth;
tveConsoleVariable *tveVoyager::cv_screenheight;
tveConsoleVariable *tveVoyager::cv_fullscreen;
tveConsoleVariable *tveVoyager::cv_logoanim;
tveConsoleVariable *tveVoyager::cv_consolekey;
float tveVoyager::ratio;


/*
 *
 */
void tveVoyager::init(int argc, char *argv[], char *props[])
{
    int i;

    tveTexture::init();
    // get the path of the application
    strcpy(path, argv[0]);
    for (i=strlen(path); (i>=0) && (path[i]!=DIR_SEP_CHAR); i--);
    if ( (i==0) && (path[0] != DIR_SEP_CHAR) )
    {
        path[i++] = '.';
    }
    path[i]   = DIR_SEP_CHAR;
    path[i+1] = '\0';

    if (props)
    {
    }
    if (argc > 1)
    {
    }
}


/*
 *
 */
gzFile tveVoyager::openFile(const char *pathname, const char *flags)
{
    char filename[256];

    sprintf(filename, "%s%s", path, pathname);
    return gzopen(filename, flags);
}


/*
 *
 */
bool tveVoyager::fileExists(const char *pathname)
{
    char filename[256];

    sprintf(filename, "%s%s", path, pathname);
    return (access(filename, 0) >= 0);
}

