/*
 * Copyright (c) 2001, Thierry Van Elsuw 
 * All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met:
 * 
 * Redistributions of source code must retain the above copyright 
 * notice, this list of conditions and the following disclaimer.
 * 
 * Redistributions in binary form must reproduce the above copyright 
 * notice, this list of conditions and the following disclaimer in the 
 * documentation and/or other materials provided with the distribution.
 * 
 * Neither the name of DS Improve nor the names of its contributors may 
 * be used to endorse or promote products derived from this software 
 * without specific prior written permission.
 * 
 * Module name   : tveVoyager.h
 * Creation date : 21/02/2001
 * e-mail        : Thierry Van Elsuwe <tvelsuwe@swing.be>
 */

#ifndef _TVEVOYAGER_H_
#define _TVEVOYAGER_H_

#include "voyager.h"
#include "tveConsole.h"
#include <zlib.h>

#define SCALE_X  2.0f
#define SCALE_Y  (1/8.0f)  //fixme: change that for TerraGen format
#define SCALE_Z  2.0f

class tveVoyager
{
private:
public:
    static char path[256];
    static tveConsoleVariable *cv_alpha;
    static tveConsoleVariable *cv_beta;
    static tveConsoleVariable *cv_gamma;
    static tveConsoleVariable *cv_far;
    static tveConsoleVariable *cv_fog;
    static tveConsoleVariable *cv_fov;
    static tveConsoleVariable *cv_speed;
    static tveConsoleVariable *cv_water;
    static tveConsoleVariable *cv_detail;
    static tveConsoleVariable *cv_posx;
    static tveConsoleVariable *cv_posy;
    static tveConsoleVariable *cv_posz;
    static tveConsoleVariable *cv_anglex;
    static tveConsoleVariable *cv_angley;
    static tveConsoleVariable *cv_screenwidth;
    static tveConsoleVariable *cv_screenheight;
    static tveConsoleVariable *cv_fullscreen;
    static tveConsoleVariable *cv_logoanim;
    static tveConsoleVariable *cv_consolekey;
    static float ratio;

    static void   init(int argc, char *argv[], char *props[]);
    static bool   fileExists(const char *pathname);
    static gzFile openFile(const char *pathname, const char *flags);
};

#endif
