/*
 * Copyright (c) 2001, Thierry Van Elsuw 
 * All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met:
 * 
 * Redistributions of source code must retain the above copyright 
 * notice, this list of conditions and the following disclaimer.
 * 
 * Redistributions in binary form must reproduce the above copyright 
 * notice, this list of conditions and the following disclaimer in the 
 * documentation and/or other materials provided with the distribution.
 * 
 * Neither the name of DS Improve nor the names of its contributors may 
 * be used to endorse or promote products derived from this software 
 * without specific prior written permission.
 * 
 * Module name   : voyager.h
 * Creation date : 14/02/2001
 * e-mail        : Thierry Van Elsuwe <tvelsuwe@swing.be>
 */

#ifndef _VOYAGER_H_
#define _VOYAGER_H_

#define DEMO_DS

#ifdef __WIN32__
#include <windows.h>
#include <io.h>
#else
#include <unistd.h>
#define O_BINARY 0
#define O_TEXT   0
#endif
//#define GL_GLEXT_PROTOTYPES
#include <GL/gl.h>
#include <GL/glu.h>
#ifndef IRIX
#include <GL/glext.h>
#endif
#include <SDL.h>
#include <SDL_endian.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include "tveVoyager.h"
#include "tveClock.h"

#define MAX(x,y) ((x) > (y) ? (x) : (y))
#define MIN(x,y) ((x) < (y) ? (x) : (y))
#define ABS(x)   ((x) > (0) ? (x) : (-(x)))
#define SRANDOM(x) ((rand() % (x)) - ((x)/2))
#define RANDOM(x) (rand() % (x))
#define NPI 3.14159265358979
#define Z(x) (-(x))

#define MAXX  1024
#define MAXZ  1024

#ifdef __WIN32__
extern PFNGLLOCKARRAYSEXTPROC           glLockArraysEXT;
extern PFNGLUNLOCKARRAYSEXTPROC         glUnlockArraysEXT;
extern PFNGLACTIVETEXTUREARBPROC        glActiveTextureARB;
extern PFNGLCLIENTACTIVETEXTUREARBPROC  glClientActiveTextureARB;
extern PFNGLMULTITEXCOORD2FARBPROC      glMultiTexCoord2fARB;

#define strncasecmp strnicmp
#define strcasecmp  stricmp
#endif

#ifdef IRIX
#define glMultiTexCoord2fARB(GL_TEXTURE_ARB, x, y) glTexCoord2f((x), (y))
#define glActiveTextureARB(GL_TEXTURE_ARB) 
#define glClientActiveTextureARB(GL_TEXTURE_ARB) 
#define glLockArraysEXT(x, y) 
#define glUnlockArraysEXT() 
#endif

#ifdef __WIN32__
#define DIR_SEP_CHAR '\\'
#else
#define DIR_SEP_CHAR '/'
#endif

enum tveRenderMethod
{
    TVE_VERTEX_ARRAY = 0,
    TVE_TRIANGLE_STRIP_LIST,
    TVE_NUM_RENDER_METHOD,
};

typedef struct
{
    GLfloat x;
    GLfloat y;
    GLfloat z;
} tveVertex;

typedef struct
{
    GLfloat s;
    GLfloat t;
} tveTexCoord;

extern tveConsole  *console;
extern tveClock    *my_clock;

#endif
